// Generated with smithy-dart 0.1.1. DO NOT MODIFY.

library smoke_test.config_service.model.external_evaluation; // ignore_for_file: no_leading_underscores_for_library_prefixes

import 'package:aws_common/aws_common.dart' as _i1;
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';
import 'package:smithy/smithy.dart' as _i3;
import 'package:smoke_test/src/sdk/src/config_service/model/compliance_type.dart'
    as _i2;

part 'external_evaluation.g.dart';

/// Identifies an Amazon Web Services resource and indicates whether it complies with the Config rule that it was evaluated against.
abstract class ExternalEvaluation
    with _i1.AWSEquatable<ExternalEvaluation>
    implements Built<ExternalEvaluation, ExternalEvaluationBuilder> {
  /// Identifies an Amazon Web Services resource and indicates whether it complies with the Config rule that it was evaluated against.
  factory ExternalEvaluation({
    String? annotation,
    required String complianceResourceId,
    required String complianceResourceType,
    required _i2.ComplianceType complianceType,
    required DateTime orderingTimestamp,
  }) {
    return _$ExternalEvaluation._(
      annotation: annotation,
      complianceResourceId: complianceResourceId,
      complianceResourceType: complianceResourceType,
      complianceType: complianceType,
      orderingTimestamp: orderingTimestamp,
    );
  }

  /// Identifies an Amazon Web Services resource and indicates whether it complies with the Config rule that it was evaluated against.
  factory ExternalEvaluation.build(
          [void Function(ExternalEvaluationBuilder) updates]) =
      _$ExternalEvaluation;

  const ExternalEvaluation._();

  static const List<_i3.SmithySerializer> serializers = [
    ExternalEvaluationAwsJson11Serializer()
  ];

  @BuiltValueHook(initializeBuilder: true)
  static void _init(ExternalEvaluationBuilder b) {}

  /// Supplementary information about the reason of compliance. For example, this task was completed on a specific date.
  String? get annotation;

  /// The evaluated compliance resource ID. Config accepts only Amazon Web Services account ID.
  String get complianceResourceId;

  /// The evaluated compliance resource type. Config accepts `AWS::::Account` resource type.
  String get complianceResourceType;

  /// The compliance of the Amazon Web Services resource. The valid values are `COMPLIANT, NON_COMPLIANT,` and `NOT_APPLICABLE`.
  _i2.ComplianceType get complianceType;

  /// The time when the compliance was recorded.
  DateTime get orderingTimestamp;
  @override
  List<Object?> get props => [
        annotation,
        complianceResourceId,
        complianceResourceType,
        complianceType,
        orderingTimestamp,
      ];
  @override
  String toString() {
    final helper = newBuiltValueToStringHelper('ExternalEvaluation');
    helper.add(
      'annotation',
      annotation,
    );
    helper.add(
      'complianceResourceId',
      complianceResourceId,
    );
    helper.add(
      'complianceResourceType',
      complianceResourceType,
    );
    helper.add(
      'complianceType',
      complianceType,
    );
    helper.add(
      'orderingTimestamp',
      orderingTimestamp,
    );
    return helper.toString();
  }
}

class ExternalEvaluationAwsJson11Serializer
    extends _i3.StructuredSmithySerializer<ExternalEvaluation> {
  const ExternalEvaluationAwsJson11Serializer() : super('ExternalEvaluation');

  @override
  Iterable<Type> get types => const [
        ExternalEvaluation,
        _$ExternalEvaluation,
      ];
  @override
  Iterable<_i3.ShapeId> get supportedProtocols => const [
        _i3.ShapeId(
          namespace: 'aws.protocols',
          shape: 'awsJson1_1',
        )
      ];
  @override
  ExternalEvaluation deserialize(
    Serializers serializers,
    Iterable<Object?> serialized, {
    FullType specifiedType = FullType.unspecified,
  }) {
    final result = ExternalEvaluationBuilder();
    final iterator = serialized.iterator;
    while (iterator.moveNext()) {
      final key = iterator.current as String;
      iterator.moveNext();
      final value = iterator.current;
      switch (key) {
        case 'Annotation':
          if (value != null) {
            result.annotation = (serializers.deserialize(
              value,
              specifiedType: const FullType(String),
            ) as String);
          }
          break;
        case 'ComplianceResourceId':
          result.complianceResourceId = (serializers.deserialize(
            value!,
            specifiedType: const FullType(String),
          ) as String);
          break;
        case 'ComplianceResourceType':
          result.complianceResourceType = (serializers.deserialize(
            value!,
            specifiedType: const FullType(String),
          ) as String);
          break;
        case 'ComplianceType':
          result.complianceType = (serializers.deserialize(
            value!,
            specifiedType: const FullType(_i2.ComplianceType),
          ) as _i2.ComplianceType);
          break;
        case 'OrderingTimestamp':
          result.orderingTimestamp = (serializers.deserialize(
            value!,
            specifiedType: const FullType(DateTime),
          ) as DateTime);
          break;
      }
    }

    return result.build();
  }

  @override
  Iterable<Object?> serialize(
    Serializers serializers,
    Object? object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    final payload = (object as ExternalEvaluation);
    final result = <Object?>[
      'ComplianceResourceId',
      serializers.serialize(
        payload.complianceResourceId,
        specifiedType: const FullType(String),
      ),
      'ComplianceResourceType',
      serializers.serialize(
        payload.complianceResourceType,
        specifiedType: const FullType(String),
      ),
      'ComplianceType',
      serializers.serialize(
        payload.complianceType,
        specifiedType: const FullType(_i2.ComplianceType),
      ),
      'OrderingTimestamp',
      serializers.serialize(
        payload.orderingTimestamp,
        specifiedType: const FullType(DateTime),
      ),
    ];
    if (payload.annotation != null) {
      result
        ..add('Annotation')
        ..add(serializers.serialize(
          payload.annotation!,
          specifiedType: const FullType(String),
        ));
    }
    return result;
  }
}
